package com.jasamedika.medifirst2000.service.impl;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.BaseConverterImpl;
import com.jasamedika.medifirst2000.converter.PapThtAnamnesisHidungConverter;
import com.jasamedika.medifirst2000.converter.PapThtAnamnesisTelingaConverter;
import com.jasamedika.medifirst2000.converter.PapThtAnamnesisTenggorokanConverter;
import com.jasamedika.medifirst2000.converter.PapThtConverter;
import com.jasamedika.medifirst2000.converter.PapThtFisikHidungConverter;
import com.jasamedika.medifirst2000.converter.PapThtFisikTelingaConverter;
import com.jasamedika.medifirst2000.converter.PapThtFisikTenggorokanConverter;
import com.jasamedika.medifirst2000.dao.PapThtDao;
import com.jasamedika.medifirst2000.dao.PasienDao;
import com.jasamedika.medifirst2000.dao.RegistrasiPelayananPasienDao;
import com.jasamedika.medifirst2000.dao.ThtDao;
import com.jasamedika.medifirst2000.entities.PapKeluhanTambahan;
import com.jasamedika.medifirst2000.entities.PapTht;
import com.jasamedika.medifirst2000.entities.PapThtAnamnesisHidung;
import com.jasamedika.medifirst2000.entities.PapThtAnamnesisTelinga;
import com.jasamedika.medifirst2000.entities.PapThtAnamnesisTenggorokan;
import com.jasamedika.medifirst2000.entities.PapThtFisikHidung;
import com.jasamedika.medifirst2000.entities.PapThtFisikTelinga;
import com.jasamedika.medifirst2000.entities.PapThtFisikTenggorokan;
import com.jasamedika.medifirst2000.entities.Pasien;
import com.jasamedika.medifirst2000.entities.RegistrasiPelayananPasien;
import com.jasamedika.medifirst2000.entities.Tht;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PapThtService;
import com.jasamedika.medifirst2000.util.CommonUtil;
import com.jasamedika.medifirst2000.vo.PapKeluhanTambahanVO;
import com.jasamedika.medifirst2000.vo.PapThtVO;
import com.jasamedika.medifirst2000.vo.ThtVO;

/**
 * Implement class for PAPThtService
 * 
 * @author Askur
 */
@Service("PAPThtService")
public class PapThtServiceImpl implements PapThtService {
	@Autowired
	private PapThtDao papThtDao;
	@Autowired
	private PapThtConverter papThtConverter;
	@Autowired
	private PapThtAnamnesisTelingaConverter papThtAnamnesisTelingaConverter;
	@Autowired
	private PapThtAnamnesisHidungConverter papThtAnamnesisHidungConverter;
	@Autowired
	private PapThtAnamnesisTenggorokanConverter papThtAnamnesisTenggorokanConverter;
	@Autowired
	private PapThtFisikTelingaConverter papThtFisikTelingaConverter;
	@Autowired
	private PapThtFisikHidungConverter papThtFisikHidungConverter;
	@Autowired
	private PapThtFisikTenggorokanConverter papThtFisikTenggorokanConverter;
	@Autowired
	private RegistrasiPelayananPasienDao registrasiPelayananPasienDao;
	@Autowired
	private PasienDao pasienDao;
	@Autowired
	private BaseConverterImpl<ThtVO, Tht> thtConverter; 
	@Autowired
	private ThtDao thtDao;
	
	@Override
	public Map<String,Object> addTht(PapThtVO vo) throws JpaSystemException, ServiceVOException {
		Map<String,Object> result=new HashMap<String,Object>();
		PapTht model=papThtConverter.transferVOToModel(vo, new PapTht());
		PapThtAnamnesisTelinga anamnesisTelinga=papThtAnamnesisTelingaConverter.transferVOToModel(vo.getPapThtAnamnesisTelinga(), new PapThtAnamnesisTelinga());
		PapThtAnamnesisHidung anamnesisHidung=papThtAnamnesisHidungConverter.transferVOToModel(vo.getPapThtAnamnesisHidung(), new PapThtAnamnesisHidung());
		PapThtAnamnesisTenggorokan anamnesisTenggorokan=papThtAnamnesisTenggorokanConverter.transferVOToModel(vo.getPapThtAnamnesisTenggorokan(), new PapThtAnamnesisTenggorokan());
		PapThtFisikTelinga fisikTelinga=papThtFisikTelingaConverter.transferVOToModel(vo.getPapThtFisikTelinga(), new PapThtFisikTelinga());
		PapThtFisikHidung fisikHidung=papThtFisikHidungConverter.transferVOToModel(vo.getPapThtFisikHidung(), new PapThtFisikHidung());
		PapThtFisikTenggorokan fisikTenggorokan=papThtFisikTenggorokanConverter.transferVOToModel(vo.getPapThtFisikTenggorokan(), new PapThtFisikTenggorokan());
		anamnesisTelinga.setPapTht(model);
		anamnesisHidung.setPapTht(model);
		anamnesisTenggorokan.setPapTht(model);
		fisikTelinga.setPapTht(model);
		fisikHidung.setPapTht(model);
		fisikTenggorokan.setPapTht(model);
		model.setPapThtAnamnesisHidung(anamnesisHidung);
		model.setPapThtAnamnesisTelinga(anamnesisTelinga);
		model.setPapThtAnamnesisTenggorokan(anamnesisTenggorokan);
		model.setPapThtFisikHidung(fisikHidung);
		model.setPapThtFisikTelinga(fisikTelinga);
		model.setPapThtFisikTenggorokan(fisikTenggorokan);
		PapTht resultModel=papThtDao.save(model);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			result.put("papTht", resultModel);
		}
		return result;
	}

	@Override
	public Map<String,Object> updateTht(PapThtVO vo) throws JpaSystemException, ServiceVOException {
		Map<String,Object> result=new HashMap<String,Object>();
		PapTht model=papThtConverter.transferVOToModel(vo, new PapTht());
		PapThtAnamnesisTelinga anamnesisTelinga=papThtAnamnesisTelingaConverter.transferVOToModel(vo.getPapThtAnamnesisTelinga(), new PapThtAnamnesisTelinga());
		PapThtAnamnesisHidung anamnesisHidung=papThtAnamnesisHidungConverter.transferVOToModel(vo.getPapThtAnamnesisHidung(), new PapThtAnamnesisHidung());
		PapThtAnamnesisTenggorokan anamnesisTenggorokan=papThtAnamnesisTenggorokanConverter.transferVOToModel(vo.getPapThtAnamnesisTenggorokan(), new PapThtAnamnesisTenggorokan());
		PapThtFisikTelinga fisikTelinga=papThtFisikTelingaConverter.transferVOToModel(vo.getPapThtFisikTelinga(), new PapThtFisikTelinga());
		PapThtFisikHidung fisikHidung=papThtFisikHidungConverter.transferVOToModel(vo.getPapThtFisikHidung(), new PapThtFisikHidung());
		PapThtFisikTenggorokan fisikTenggorokan=papThtFisikTenggorokanConverter.transferVOToModel(vo.getPapThtFisikTenggorokan(), new PapThtFisikTenggorokan());
		anamnesisTelinga.setPapTht(model);
		anamnesisHidung.setPapTht(model);
		anamnesisTenggorokan.setPapTht(model);
		fisikTelinga.setPapTht(model);
		fisikHidung.setPapTht(model);
		fisikTenggorokan.setPapTht(model);
		model.setPapThtAnamnesisHidung(anamnesisHidung);
		model.setPapThtAnamnesisTelinga(anamnesisTelinga);
		model.setPapThtAnamnesisTenggorokan(anamnesisTenggorokan);
		model.setPapThtFisikHidung(fisikHidung);
		model.setPapThtFisikTelinga(fisikTelinga);
		model.setPapThtFisikTenggorokan(fisikTenggorokan);
		PapTht resultModel=papThtDao.save(model);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			result.put("papTht", resultModel);
			result.put("dataFound", true);
		}else{
			result.put("dataFound", false);			
		}
		return result;
	}

	@Override
	public List<PapThtVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String,Object> findByNoCmAndTglInput(String noCm, Date tglInput) {
		Map<String,Object> result=new HashMap<String,Object>();
		PapTht resultModel=papThtDao.findPapThtByNoCmAndTglInput(noCm, tglInput);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			result.put("papTht", resultModel);
			result.put("dataFound", true);
		} else {
			result.put("dataFound", false);
		}
		return result;
	}

	@Override
	public Map<String,Object> findRegistrasiPelayananPasienByNoCmAndTglRegistrasi(String noCm, short kdProfile,Date tglRegistrasi) {
		Map<String,Object> result=new HashMap<String,Object>();
		RegistrasiPelayananPasien resultModel=registrasiPelayananPasienDao.finByNoCm(noCm,kdProfile,tglRegistrasi);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			result.put("noRec", resultModel.getNoRec());
			result.put("tglRegistrasi", resultModel.getTglMasuk());
			result.put("noAntrian", resultModel.getNoAntrian());
			result.put("dataFound", true);
			if(CommonUtil.isNotNullOrEmpty(resultModel.getPasien().getId())){
				result.put("pasien.noCm", resultModel.getPasien().getNoCm());
			}
		}else{
			result.put("dataFound", false);
		}
		return result;
	}

	@Override
	public Map<String,Object> findPasienByNoCm(String noCm) {
		Map<String,Object> result=new HashMap<String,Object>();
		List<Pasien> resultModel=pasienDao.findPasienBynoCm(noCm);
		if(CommonUtil.isNotNullOrEmpty(resultModel)){
			for(Pasien pasien:resultModel){
				result.put("noCm", pasien.getNoCm());
				result.put("namaPasien", pasien.getNamaPasien());
				if(CommonUtil.isNotNullOrEmpty((pasien.getAlamats().iterator().next()))){
				result.put("alamatLengkap", (pasien.getAlamats().iterator().next()).getAlamatLengkap());
				}
				if(CommonUtil.isNotNullOrEmpty(pasien.getJenisKelamin())){
				result.put("jenisKelamin", pasien.getJenisKelamin().getNamaExternal());
				}
				if(CommonUtil.isNotNullOrEmpty(pasien.getStatusPerkawinan())){
				result.put("statusPerkawinan", pasien.getStatusPerkawinan().getNamaExternal());
				}
				result.put("dataFound", true);
			}
		}else{
			result.put("dataFound", false);
		}
		return result;
	}

	@Override
	public Object add(Object vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Object update(Object vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(Object key) throws JpaSystemException {
		return null;
	}

	@Override
	public Object findById(Object key) throws JpaSystemException {
		return null;
	}

	@Override
	public Map findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit, String sort,
			String dir) {
		return null;
	}

}
